Boomkinator = LibStub("AceAddon-3.0"):NewAddon("Boomkinator", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local L    = LibStub("AceLocale-3.0"):GetLocale("Boomkinator")

local settings
local UnitBuff = _G.UnitBuff
local UnitDebuff = _G.UnitDebuff
local GetSpellInfo = _G.GetSpellInfo
local GetSpellCooldown= _G.GetSpellCooldown
local sformat = string.format

local updater = ""
local hasSunfire = 0
local hasStars = 0

-- buttons
local buttons = {}
local timers = {}
local ccount

--local bframe, bisIcon, bisTime, bmfIcon, bmfTime, bwrtIcon, bstfIcon, bstsIcon, bstsTime, bfonIcon, bfonTime, bsflIcon, bsflTime
--local bshIcon, brpIcon, brpTime, brpCount, bmnIcon, bmnTime, bsrIcon, bsrTime, brkIcon, brkTime, btfIcon, btfTime, bbsIcon, bbsTime

local mfName, mfIcon, sfName, sfIcon
local bLastCycle = 0

Boomkinator.Credits1 = "Boomkinator - by Aznamir (Lightbringer US)";

-------------------------------------------------------------------
-- Spell Settings
-------------------------------------------------------------------
Boomkinator.OwlSpells = {
	[1] = GetSpellInfo(5570),  -- Insect Swarm
	[2] = GetSpellInfo(8921),  -- Moonfire
	[3] = GetSpellInfo(93402), -- Sunfire
	[4] = GetSpellInfo(5176),  -- Wrath
	[5] = GetSpellInfo(2912),  -- Starfire
	[6] = GetSpellInfo(78674), -- Starsurge
	[7] = GetSpellInfo(33831), -- Treants
	[8] = GetSpellInfo(50288), -- Starfall
	[9] = GetSpellInfo(48518), --eclipse lunar
	[10]= GetSpellInfo(48517), --eclipse solar
	[11]= GetSpellInfo(93400), -- shooting stars
}

Boomkinator.CatSpells = {
	[1] = GetSpellInfo(5221), -- shred
	[2] = GetSpellInfo(1079), -- rip
	[3] = GetSpellInfo(33876), -- mangle
	[4] = GetSpellInfo(1822), -- rake	
	[5] = GetSpellInfo(52610), -- savage roar
	[6] = GetSpellInfo(50334), -- berserk
	[7] = GetSpellInfo(5217), -- tiger's fury
	[8] = GetSpellInfo(46857) -- trauma (warrior)
}

Boomkinator.HunterSpells = {
	[1] = GetSpellInfo(53209), -- Chimera Shot
	[2] = GetSpellInfo(53301), -- Explosive Shot
	[3] = GetSpellInfo(3674), -- Black Arrow
	[4] = GetSpellInfo(1978), -- Serpent Sting
	[5] = GetSpellInfo(53351), -- Kill Shot
}

Boomkinator.Icons = {
	["Owl"] = {
		[1] = "Interface\\Icons\\Spell_Nature_InsectSwarm",
		[2] = "Interface\\Icons\\Spell_Nature_StarFall",
		[3] = "Interface\\Icons\\Spell_Arcane_StarFire",
		[4] = "Interface\\Icons\\Spell_Arcane_Arcane03",
		[5] = "Interface\\Icons\\Spell_Nature_AbolishMagic",
		[6] = "Interface\\Icons\\Ability_Druid_ForceofNature",
		[7] = "Interface\\Icons\\Ability_Druid_Starfall",
	},
	["Cat"] = {
		[1] = "Interface\\Icons\\Spell_Shadow_VampiricAura",
		[2] = "Interface\\Icons\\Ability_GhoulFrenzy",
		[3] = "Interface\\Icons\\Ability_Druid_Mangle2",
		[4] = "Interface\\Icons\\Ability_Druid_SkinTeeth",
		[5] = "Interface\\Icons\\Ability_Druid_Disembowel",
		[6] = "Interface\\Icons\\Ability_Mount_JungleTiger",
		[7] = "Interface\\Icons\\Ability_Druid_Berserk",
	},
	["Hunter"] = {
		[1] = "Interface\\Icons\\Ability_Hunter_ChimeraShot2",
		[2] = "Interface\\Icons\\Ability_Hunter_ExplosiveShot",
		[3] = "Interface\\Icons\\Spell_Shadow_PainSpike",
		[4] = "Interface\\Icons\\Ability_Hunter_Quickshot",
		[5] = "Interface\\Icons\\Ability_Hunter_Assassinate2",
		[6] = "",
		[7] = "",
	},
	["None"] = {
		[1] = "",
		[2] = "",
		[3] = "",
		[4] = "",
		[5] = "",
		[6] = "",
		[7] = "",
	},
}
-------------------------------------------------------------------
-- Interface settings
-------------------------------------------------------------------
Boomkinator.options =
{
	type = "group",
	name = "Boomkinator",
	args = {
		desc = {
			type = "description",
			order = 0,
			name = L["MOVE_DESC"],
		},
		reset = {
			type = "execute",
			order = 1,
			name = L["RESET"],
			desc = L["RESET_DESC"],
			func = function() Boomkinator:Reset() end,
		},
		show = {
			type = "execute",
			order = 2,
			name = L["SHOW"],
			desc = L["SHOW_DESC"],
			func = function() Boomkinator:ShowLayout() end,
		},
		hide = {
			type = "execute",
			order = 3,
			name = L["HIDE"],
			desc = L["HIDE_DESC"],
			func = function() Boomkinator:HideLayout() end,
		},
		lock = {
			type = "execute",
			order = 4,
			name = L["LOCK"],
			desc = L["LOCK_DESC"],
			func = function() 
					settings.locked = true
					Boomkinator:LockLayout() 
				end,
		},
		unlock = {
			type = "execute",
			order = 5,
			name = L["UNLOCK"],
			desc = L["UNLOCK_DESC"],
			func = function()
					settings.locked = false
					Boomkinator:UnlockLayout()
				end,
		},
		scale = {
			type = "range",
			order = 6,
			name = L["BSC"],
			desc = L["BSC_DESC"],
			min = 0.4,
			max = 1.5,
			step = 0.05,
			get = function(info) return settings.buffscale end,
			set = function(info, val)
					settings.buffscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		fontscale = {
			type = "range",
			order = 7,
			name = "Font Scale",
			desc = "Scale of timer fonts", 
			min = 8,
			max = 14,
			step = 1,
			get = function(info) return settings.fontscale end,
			set = function(info, val)
					settings.fontscale = val
					Boomkinator:UpdateLayout()
				end,
		}
	},
}
-------------------------------------------------------------------
-- Default Settings
-------------------------------------------------------------------
Boomkinator.defaults = {
	profile = {
		buffscale = 0.9,
		fontscale = 10,
		locked = false,
		disabled = false,
	}
}
-------------------------------------------------------------------
-- Ace Framework Events
-------------------------------------------------------------------
function Boomkinator:OnInitialize()
	--self:Print("OnInitialize")
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99"..Boomkinator.Credits1.."|r")
	self.db = LibStub("AceDB-3.0"):New("BoomkinatorDB", Boomkinator.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	settings = self.db.profile
	Boomkinator.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Boomkinator", Boomkinator.options, "boom")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Boomkinator", "Boomkinator")

	self:UpdateLayout()
end

function Boomkinator:OnProfileChanged()
	--self:Print("OnProfileChanged")
	settings = self.db.profile
	self:UpdateLayout()
end

function Boomkinator:OnEnable()
	--self:Print("OnEnable")
	settings.disabled = false
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:UpdateLayout()
end

function Boomkinator:OnDisable()
	--self:Print("OnDisable")
	-- events
	settings.disabled = true
	self:UpdateLayout()
end

function Boomkinator:MediaUpdate()

end
-------------------------------------------------------------------
-- Service Functions
-------------------------------------------------------------------
function Boomkinator:FormatTime(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	local mins = floor(time / 60)
	local secs = time - (mins * 60)
	return sformat("%d:%02d", mins, secs)
end

function Boomkinator:FormatShort(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	return sformat("%0.1f", time)
end
-------------------------------------------------------------------
-- Command Prompt Response
-------------------------------------------------------------------
function Boomkinator:Reset()
	local h = _G["BoomkinatorFrame"]
	h:ClearAllPoints()
	h:SetPoint("CENTER", "UIParent", "CENTER", 0, 0)
	--self:UpdateLayout()
end

-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

-------------------------------------------------------------------
-- External Event Handling
------------------------------------------------------------------
function Boomkinator:PLAYER_REGEN_ENABLED()
	--self:Print("Regen Enabled")
	self:CancelTimer(self.UpdateTimer, true)
	self:HideLayout()
end

function Boomkinator:PLAYER_REGEN_DISABLED()
	--self:Print("Regen Disabled")

	if updater == "" then
		--self:Print("Entered combat without settings, trying to fix UI")
		self:UpdateLayout()
	end
	
	if updater ~= "" then
		--self:Print(updater)
		self.UpdateTimer = self:ScheduleRepeatingTimer(updater, 0.1)
		self:ShowLayout()		
	end
end

function Boomkinator:ACTIVE_TALENT_GROUP_CHANGED()
	--self:Print("Talents Changed")
	self:UpdateLayout()
end

function Boomkinator:CheckTalents()
	--self:Print("Check Talents")
	local _, class = UnitClass("player")
	if (class == "DRUID") and select(5, GetTalentInfo(1,20)) == 1 then -- moonkin
		hasSunfire = select(5, GetTalentInfo(1,16))
		hasStars = select(5, GetTalentInfo(1,10))
		updater = "ButtonsOwlUpdate"
		--self:Print("Owl spec")
    elseif (class == "DRUID") and select(5, GetTalentInfo(2,22)) == 1 then -- cat
		updater = "ButtonsCatUpdate"
		--self:Print("Cat spec")		
	elseif class == "HUNTER" then -- hunter
		updater = "ButtonsHunterUpdate"
		--self:Print("Hunter")   
	else
		updater = ""
		--self:Print("")	
	end
end
-------------------------------------------------------------------
-- Buff UI
-------------------------------------------------------------------
function Boomkinator:UpdateLayout()
	--self:Print("Update Layout")
	local icons
	
	self:CheckTalents()
	
	--self:Print(updater)
	
	if updater == "ButtonsOwlUpdate" then
		icons = Boomkinator.Icons["Owl"]
		-- extra icons for eclipses
		mfName, _, mfIcon = GetSpellInfo(8921) -- Moonfire
		sfName, _, sfIcon = GetSpellInfo(93402) -- Sunfire
	elseif updater == "ButtonsCatUpdate" then
		icons = Boomkinator.Icons["Cat"]
	elseif updater == "ButtonsHunterUpdate" then
		icons = Boomkinator.Icons["Hunter"]
	else
		icons = Boomkinator.Icons["None"]
	end
	
	if updater ~= nil then
		--self:Print("Acceptable updater, setting icons")
		bframe = _G["BoomkinatorFrame"]
		ccount = _G["BoomkinatorFrameCCount"]
		ccount:SetText("")
		for i = 1, 7 do
			--self:Print(i .." " .. icons[i])
			buttons[i] = _G["BoomkinatorFrameButton"..i]
			buttons[i]:SetTexture(icons[i])
			buttons[i]:SetVertexColor(1, 1, 1, 1)
			timers[i]  = _G["BoomkinatorFrameTime"..i]
			timers[i]:SetText("")
			timers[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
		end
	end

	BoomkinatorFrame:SetScale(settings.buffscale)
	self:HideLayout()

	if settings.locked then
		Boomkinator:LockLayout()
	else
		Boomkinator:UnlockLayout()
	end
end

function Boomkinator:ShowLayout()
	bframe:Show()
end

function Boomkinator:HideLayout()
	bframe:Hide()
end

function Boomkinator:LockLayout()
	bframe:EnableMouse(false)
end

function Boomkinator:UnlockLayout()
	bframe:EnableMouse(true)
end

function Boomkinator:GetSeverityColor(percent)
	if (percent >= 0.5) then
		return (1.0-percent)*2, 1.0, 0.0
	else
		return 1.0, percent*2, 0.0
	end
end

function Boomkinator:ButtonsCatUpdate()
	local expire
	local spellName, spellIcon
	local combos
	
	-- self buffs: savage roar
	spellName = Boomkinator.CatSpells[5]
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	
	if buffName and buffExpire then
		expire = buffExpire - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	else
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	end
	
	-- target debuffs
	if UnitExists("target") then
		-- check combo points
		combos = GetComboPoints("player", "target")
	
		if combos == 0 then
			ccount:SetText("-")
		else
			ccount:SetText(combos)
		end
	
		-- rip
		spellName = Boomkinator.CatSpells[2]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[2]:SetText(Boomkinator:FormatShort(expire))
			buttons[2]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[2]:SetText("")
			buttons[2]:SetVertexColor(1, 1, 1, 1)
		end
	
		-- mangle
		spellName = Boomkinator.CatSpells[3]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil)
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[3]:SetText(Boomkinator:FormatShort(expire))
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		else
			-- check for trauma
			spellName = Boomkinator.CatSpells[8]
			_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil)
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[3]:SetText(Boomkinator:FormatShort(expire))
				buttons[3]:SetVertexColor(1, 1, 1, 0.3)
			else
				timers[3]:SetText("")
				buttons[3]:SetVertexColor(1, 1, 1, 1)
			end
		end

		-- rake
		spellName = Boomkinator.CatSpells[4]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[5]:SetText(Boomkinator:FormatShort(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		end
	end
	
	-- check cooldowns
	local start, duration, berserk

	spellName = Boomkinator.CatSpells[6]
	-- check active berserk
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		berserk = 1
	else 
		berserk = 0
	end
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[7]:SetText("")
		buttons[7]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[7]:SetText(Boomkinator:FormatTime(expire))
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- tiger's fury	
	spellName =  Boomkinator.CatSpells[7]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[6]:SetText("")
		if berserk == 0 then
			buttons[6]:SetVertexColor(1, 1, 1, 1)
		else -- blocked
			buttons[6]:SetVertexColor(1, 1, 1, 0.3)
		end
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[6]:SetText(Boomkinator:FormatShort(expire))
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end
end

function Boomkinator:ButtonsOwlUpdate()
	local expire
	local mooncycle = 0
	local suncycle  = 0
	local spellName, spellIcon
	local stars = 0
	-- show Moonfire or Sunfire

	local mfDuration, mfExpire, sfDuration, sfExpire

	spellName = Boomkinator.OwlSpells[9] -- lunar
	local buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		mooncycle = 1
		bLastCycle = 1
	end

	spellName = Boomkinator.OwlSpells[10] -- solar
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		suncycle = 1
		bLastCycle = 2
	end
	
	spellName = Boomkinator.OwlSpells[11] -- shooting stars
	buffName, _, _, _, _, buffDuration, buffExpire = UnitBuff("player", spellName)
	if buffName then
		stars = 1
	end
	
	if UnitExists("target") then
		-- checking for debuffs on the target
		
		-- insect swarm
		local spellName = Boomkinator.OwlSpells[1]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")

		if buffExpire then
			expire = buffExpire - GetTime()
			timers[1]:SetText(Boomkinator:FormatShort(expire))
			buttons[1]:SetVertexColor(1, 1, 1, 0.3)
			-- icon is permanent
		else
			timers[1]:SetText("")
			buttons[1]:SetVertexColor(1, 1, 1, 1)
			-- icon is permanent
		end

		-- moonfire and sunfire
		_, _, _, _, _, mfDuration, mfExpire = UnitDebuff("target", mfName, nil, "PLAYER")
		_, _, _, _, _, sfDuration, sfExpire = UnitDebuff("target", sfName, nil, "PLAYER")

		if mooncycle == 0 and suncycle == 0 then
			-- in the middle of cycles
			if sfExpire then -- sunfire still active
				expire = sfExpire - GetTime()
				timers[2]:SetText(Boomkinator:FormatShort(expire))
				buttons[2]:SetVertexColor(1, 1, 1, 0.3)
				buttons[2]:SetTexture(sfIcon)
			else
				if mfExpire then -- moonfire still active
					expire = mfExpire - GetTime()
					timers[2]:SetText(Boomkinator:FormatShort(expire))
					buttons[2]:SetVertexColor(1, 1, 1, 0.3)
				else -- moonfire inactive
					timers[2]:SetText("")
					buttons[2]:SetVertexColor(1, 1, 1, 1)
				end
				buttons[2]:SetTexture(mfIcon)
			end
		else
			-- moonfire or sunfire active
			if suncycle == 0 or hasSunfire == 0 then
				-- moonfire
				spellName, _, spellIcon = GetSpellInfo(8921) -- Moonfire
			else
				-- sunfire
				spellName, _, spellIcon = GetSpellInfo(93402) -- Sunfire
			end
			_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
			
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[2]:SetText(Boomkinator:FormatShort(expire))
				buttons[2]:SetTexture(spellIcon)
				buttons[2]:SetVertexColor(1, 1, 1, 0.3)
			else
				timers[2]:SetText("")
				buttons[2]:SetTexture(spellIcon)
				buttons[2]:SetVertexColor(1, 1, 1, 1)
			end
		end
	end
	
	-- wrath or stafire
	if mooncycle == 1 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	elseif suncycle == 1 then
		buttons[5]:SetVertexColor(1, 1, 1, 1)
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	else
		if bLastCycle == 1 then -- from moon to sun
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
			buttons[3]:SetVertexColor(1, 1, 1, 1)
		elseif bLastCycle == 2 then -- from Sun to Moon
			buttons[5]:SetVertexColor(1, 1, 1, 1)
			buttons[3]:SetVertexColor(1, 1, 1, 0.3)
		else -- unknown transition
			buttons[5]:SetVertexColor(1, 1, 1, 0.75)
			buttons[3]:SetVertexColor(1, 1, 1, 0.75)
		end
	end
	timers[3]:SetText("")
	timers[5]:SetText("")
	
	-- check cooldowns
	local start, duration
	-- starsurge
	spellName = Boomkinator.OwlSpells[6]
	start, duration = GetSpellCooldown(spellName)

	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[4]:SetText("")
		buttons[4]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[4]:SetText(Boomkinator:FormatShort(expire))
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- treants
	spellName = Boomkinator.OwlSpells[7]
	start, duration = GetSpellCooldown(spellName)

	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[6]:SetText("")
		buttons[6]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[6]:SetText(Boomkinator:FormatTime(expire))
		buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- starfall
	spellName = Boomkinator.OwlSpells[8]
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[7]:SetText("")
		buttons[7]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[7]:SetText(Boomkinator:FormatTime(expire))
		buttons[7]:SetVertexColor(1, 1, 1, 0.3)
	end
end

function Boomkinator:ButtonsHunterUpdate()
	local expire
	local spellName, spellIcon
	
	
	-- target debuffs
	if UnitExists("target") then
	
		-- Serpent Sting
		spellName = Boomkinator.HunterSpells[4]
		_, _, _, _, _, buffDuration, buffExpire = UnitDebuff("target", spellName, nil, "PLAYER")
		
		if buffExpire then
			expire = buffExpire - GetTime()
			timers[4]:SetText(Boomkinator:FormatShort(expire))
			buttons[4]:SetVertexColor(1, 1, 1, 0.3)
		else
			timers[4]:SetText("")
			buttons[4]:SetVertexColor(1, 1, 1, 1)
		end

	end
	
	-- check cooldowns
	local start, duration

	spellName = Boomkinator.HunterSpells[1]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[1]:SetText("")
		buttons[1]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[1]:SetText(Boomkinator:FormatTime(expire))
		buttons[1]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- Explovive Shot	
	spellName =  Boomkinator.HunterSpells[2]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[2]:SetText("")
		buttons[2]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[2]:SetText(Boomkinator:FormatShort(expire))
		buttons[2]:SetVertexColor(1, 1, 1, 0.3)
	end

	-- Black Arrow	
	spellName =  Boomkinator.HunterSpells[3]
	-- check cooldown
	start, duration = GetSpellCooldown(spellName)
	if start == 0 or (start > 0 and duration < 1.5 ) then
		timers[3]:SetText("")
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	else
	-- on cooldown
		expire = start + duration - GetTime()
		timers[3]:SetText(Boomkinator:FormatShort(expire))
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	--Check Kill Shot
	spellname = Boomkinator.HunterSpells[5]
	if UnitHealth("target")/UnitMaxHealth("target") > 0.2 then 
		-- too soon
		timers[5]:SetText("")
		buttons[5]:SetVertexColor(1, 1, 1, 0.3)
	else
		--check cooldown
		start, duration = GetSpellCooldown(spellName)
		if start == 0 or (start > 0 and duration < 1.5 ) then
			timers[5]:SetText("")
			buttons[5]:SetVertexColor(1, 1, 1, 1)
		else
		-- on cooldown
			expire = start + duration - GetTime()
			timers[5]:SetText(Boomkinator:FormatTime(expire))
			buttons[5]:SetVertexColor(1, 1, 1, 0.3)
		end
	end
end